/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along with this
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
q3master@hendriklipka.de
*/

package de.hendriklipka.q3master.handler.heartbeat;

import de.hendriklipka.q3master.HeartbeatHandler;
import de.hendriklipka.q3master.ServerStateManager;
import de.hendriklipka.q3master.ServerData;

import java.net.InetAddress;

import org.apache.log4j.Category;

public class FlatlineHeartbeat implements HeartbeatHandler
{
    private Category CAT = Category.getInstance(FlatlineHeartbeat.class.getName());
    private Category LOG_CAT = Category.getInstance("q3master.heartbeat");

    public void handleHeartbeat(InetAddress serverAddress, int port, ServerStateManager handler)
    {
        // create server data object and set known data
        ServerData sd = new ServerData();
        sd._serverAddress = serverAddress;
        sd._serverPort = port;
        sd._lastHeartBeat = System.currentTimeMillis();
        
        handler.removeServer(sd);
    }
}
