package de.hendriklipka.q3master.test;

import java.net.DatagramSocket;
import java.net.SocketException;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.io.IOException;

public class ClientBaseSimulation
{
    DatagramSocket _socket=null;
    private InetAddress _server;
    long _lastSendTime=System.currentTimeMillis();
    private int _port;

    public ClientBaseSimulation(int port, InetAddress serverAddress)
    {
        System.err.print(".");
        try
        {
            _socket=new DatagramSocket(port);
            _server=serverAddress;
            _port=port;
        }
        catch (SocketException e)
        {
            e.printStackTrace();
        }
        new QueryResponseListener().start();
    }

    protected void queryServers()
    {
        byte[] data=new byte[28];
        data[0]=-1;
        data[1]=-1;
        data[2]=-1;
        data[3]=-1;
        data[4]='g';
        data[5]='e';
        data[6]='t';
        data[7]='s';
        data[8]='e';
        data[9]='r';
        data[10]='v';
        data[11]='e';
        data[12]='r';
        data[13]='s';
        data[14]=' ';
        data[15]='4';
        data[16]='3';
        data[17]=' ';
        data[18]='f';
        data[19]='u';
        data[20]='l';
        data[21]='l';
        data[22]=' ';
        data[23]='e';
        data[24]='m';
        data[25]='p';
        data[26]='t';
        data[27]='y';
        DatagramPacket packet=new DatagramPacket(data, 28,_server,27950);
        try
        {
            _socket.send(packet);
            _lastSendTime=System.currentTimeMillis();
//            System.out.print("#");
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
    }

    private class QueryResponseListener extends Thread
    {
        public QueryResponseListener()
        {
            setDaemon(true);
        }
        
        public void run()
        {
            while (true)
            {
                byte[] data=new byte[65535];
                DatagramPacket packet=new DatagramPacket(data,65535);
                try
                {
                    _socket.receive(packet);
                    long receiveTime=System.currentTimeMillis();
                    long time=receiveTime-_lastSendTime;
                    System.out.println("receive time on port "+_port+" ="+time);
                }
                catch (IOException e)
                {
                    e.printStackTrace();
                }
            }
        }
    }
}
