package de.hendriklipka.q3master.test;

import java.util.ArrayList;
import java.util.Random;
import java.util.Iterator;
import java.net.InetAddress;
import java.net.UnknownHostException;

public class ClientSimulator
{
    private static ArrayList _threads=new ArrayList();

    public static void main(String[] args)
    {
        InetAddress server=null;
        try
        {
            server=InetAddress.getByName("192.168.0.4");
//            server=InetAddress.getByName("127.0.0.1");
        }
        catch (UnknownHostException e)
        {
            e.printStackTrace();
        }
        for (int i=0; i<500; i++)
        {
            ClientSimulation sim=new ClientBrowserSimulation(10000+i,server);
            ClientThread thread=new ClientThread(sim);
            _threads.add(thread);
        }
        for (int i=0; i<500; i++)
        {
            ClientSimulation sim=new ClientPlayingSimulation(20000+i,server);
            ClientThread thread=new ClientThread(sim);
            _threads.add(thread);
        }
        System.out.println("");
        Random rand=new Random();
        System.err.println("created simulators");
        int count=0;
        for (Iterator iterator=_threads.iterator(); iterator.hasNext();)
        {
            count++;
            System.out.println(count);
            Thread simulation=(Thread)iterator.next();
            simulation.start();
            int time=rand.nextInt(50)+5;
            synchronized (rand)
            {
                try
                {
                    rand.wait(time);
                }
                catch (InterruptedException ex)
                {
                }
            }
        }
        System.err.println("started simulators");
    }

    private static class ClientThread extends Thread
    {
        private ClientSimulation _simulator;

        public void stopSimulation()
        {
            _running=false;
        }

        private boolean _running=true;

        public ClientThread(ClientSimulation simulator)
        {
            _simulator=simulator;
        }

        public void run()
        {
            while (_running)
            {
//                System.out.print("+");
                _simulator.doSomething();
                long sleepTime=_simulator.getSleepTime();
                synchronized (this)
                {
                    try
                    {
                        this.wait(sleepTime);
                    }
                    catch (InterruptedException ex)
                    {
                    }
                }
            }
            System.out.println("finished simulator");
        }
    }

}
