package de.hendriklipka.q3master.test;

import java.net.DatagramSocket;
import java.net.SocketException;
import java.net.InetAddress;
import java.net.DatagramPacket;
import java.io.IOException;

public class ServerBaseSimulation
{
    public static final int STATE_OFF=0;
    public static final int STATE_ON=1;
    public static final int STATE_PLAYERS=2;

    DatagramSocket _socket=null;
    private InetAddress _server;
    private int _port;
    int _players=0;
    int _currentState=STATE_ON;

    public ServerBaseSimulation(int port, InetAddress server)
    {
        _server=server;
        _port=port;
        try
        {
            _socket=new DatagramSocket(port);
        }
        catch (SocketException e)
        {
            e.printStackTrace();
        }
        new QueryResponseListener().start();
    }

    protected void heartBeat()
    {
        byte[] data=new byte[27];
        data[0]=-1;
        data[1]=-1;
        data[2]=-1;
        data[3]=-1;
        data[4]='h';
        data[5]='e';
        data[6]='a';
        data[7]='r';
        data[8]='t';
        data[9]='b';
        data[10]='e';
        data[11]='a';
        data[12]='t';
        data[13]=' ';
        data[14]='Q';
        data[15]='u';
        data[16]='a';
        data[17]='k';
        data[18]='e';
        data[19]='A';
        data[20]='r';
        data[21]='e';
        data[22]='n';
        data[23]='a';
        data[24]='-';
        data[25]='1';
        data[26]=0x0a;
        DatagramPacket packet=new DatagramPacket(data, 27,_server,27950);
        try
        {
            _socket.send(packet);
            System.err.print("#");
//            System.out.println("heartbeat on port "+_port);
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
    }

    private class QueryResponseListener extends Thread
    {
        public QueryResponseListener()
        {
            setDaemon(true);
        }
        
        public void run()
        {
            while (true)
            {
                byte[] data=new byte[65535];
                DatagramPacket packet=new DatagramPacket(data,65535);
                try
                {
                    _socket.receive(packet);
                    System.err.print("_");
                    if (_server.equals(packet.getAddress()))
                    {
                        int len=packet.getLength();
                        StringBuffer sb=new StringBuffer();
                        for (int i=0; i<len; i++)
                            sb.append((char)packet.getData()[i]);
                        String result=resultToString(sb.toString());
                        if (result.startsWith("getstatus")&&_currentState!=STATE_OFF)
                        {
//                            System.out.println("status request on port "+_port);
                            String s="statusResponse\nsv_maxclients\\32\\protocol\\43";
                            for (int i=0;i<_players;i++)
                            {
                                s+="\n-1 0 PLAYER"+i;
                            }
                            byte[] response=new byte[4+s.length()];
                            response[0]=-1;
                            response[1]=-1;
                            response[2]=-1;
                            response[3]=-1;
                            for (int i=0;i<s.length();i++)
                            {
                                response[i+4]=(byte)s.charAt(i);
                            }
                            DatagramPacket p=new DatagramPacket(response,response.length,_server,packet.getPort());
                            _socket.send(p);
                            System.err.print("+");
//                            System.out.println("sent response on port "+_port);
                        }
                    }
                }
                catch (IOException e)
                {
                    e.printStackTrace();
                }
            }
        }
    }

    protected String resultToString(String s)
    {
        while ((char)-1==s.charAt(0))
            s=s.substring(1);
        if (s.startsWith("n"))
            s=s.substring(1);
        if (s.startsWith("\\"))
            s=s.substring(1);
        return s;
    }
}
